﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;
//using OutLook = Microsoft.Office.Interop.Outlook;
using System.Security.Principal;

namespace IdentificadorDeTrucades
{
    class GestorHistorial : Form
    {

        #region Atributs de la classe GestorHistorial

        private Button Tancar;
        private DataGridViewTextBoxColumn Hora;
        private DataGridViewTextBoxColumn Nom;
        private DataGridViewLinkColumn Telefon;
        private DataGridViewLinkColumn Departament;
        private DataGridViewLinkColumn Correu;
        private DataGridView Graella;

        private XmlDocument doc_xml = new XmlDocument();
         
        #endregion

        #region Constructor de la classe GestorHistorial

        public GestorHistorial()
        {
            InitializeComponent();

            //Carrego el fitxer xml
            doc_xml.Load("Hist.xml");

        }

        #endregion

        #region Metodes de la classe GestorHistorial

        //Inicialitza l'historial amb tots els seus parametres
        private void InitializeComponent()
        {
            this.Tancar = new System.Windows.Forms.Button();
            this.Graella = new System.Windows.Forms.DataGridView();
            this.Hora = new System.Windows.Forms.DataGridViewTextBoxColumn();
            this.Nom = new System.Windows.Forms.DataGridViewTextBoxColumn();
            this.Telefon = new System.Windows.Forms.DataGridViewLinkColumn();
            this.Departament = new System.Windows.Forms.DataGridViewLinkColumn();
            this.Correu = new System.Windows.Forms.DataGridViewLinkColumn();
            ((System.ComponentModel.ISupportInitialize)(this.Graella)).BeginInit();
            this.SuspendLayout();
            // 
            // Tancar
            // 
            this.Tancar.Location = new System.Drawing.Point(554, 2);
            this.Tancar.Name = "Tancar";
            this.Tancar.Size = new System.Drawing.Size(17, 18);
            this.Tancar.TabIndex = 0;
            this.Tancar.Text = "X";
            this.Tancar.UseVisualStyleBackColor = true;
            this.Tancar.Click += new System.EventHandler(this.Tancar_Historial);
            // 
            // Graella
            // 
            this.Graella.AllowUserToAddRows = false;
            this.Graella.AllowUserToDeleteRows = false;
            this.Graella.AllowUserToResizeColumns = false;
            this.Graella.AllowUserToResizeRows = false;
            this.Graella.AutoSizeColumnsMode = System.Windows.Forms.DataGridViewAutoSizeColumnsMode.DisplayedCells;
            this.Graella.BackgroundColor = System.Drawing.Color.AliceBlue;
            this.Graella.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.Graella.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
            this.Graella.Columns.AddRange(new System.Windows.Forms.DataGridViewColumn[] {
            this.Hora,
            this.Nom,
            this.Telefon,
            this.Departament,
            this.Correu});
            this.Graella.GridColor = System.Drawing.Color.AliceBlue;
            this.Graella.Location = new System.Drawing.Point(12, 12);
            this.Graella.Name = "Graella";
            this.Graella.ReadOnly = true;
            this.Graella.Size = new System.Drawing.Size(517, 64);
            this.Graella.TabIndex = 0;
            // 
            // Hora
            // 
            this.Hora.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.AllCells;
            this.Hora.HeaderText = "Hora";
            this.Hora.Name = "Hora";
            this.Hora.ReadOnly = true;
            this.Hora.Resizable = System.Windows.Forms.DataGridViewTriState.False;
            this.Hora.Width = 55;
            // 
            // Nom
            // 
            this.Nom.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.AllCells;
            this.Nom.HeaderText = "Nom";
            this.Nom.Name = "Nom";
            this.Nom.ReadOnly = true;
            this.Nom.Resizable = System.Windows.Forms.DataGridViewTriState.False;
            this.Nom.Width = 54;
            // 
            // Telefon
            // 
            this.Telefon.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.AllCells;
            this.Telefon.HeaderText = "Telefón";
            this.Telefon.Name = "Telefon";
            this.Telefon.ReadOnly = true;
            this.Telefon.Resizable = System.Windows.Forms.DataGridViewTriState.False;
            this.Telefon.SortMode = System.Windows.Forms.DataGridViewColumnSortMode.Automatic;
            this.Telefon.Width = 68;
            // 
            // Departament
            // 
            this.Departament.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.AllCells;
            this.Departament.HeaderText = "Departament";
            this.Departament.Name = "Departament";
            this.Departament.ReadOnly = true;
            this.Departament.Resizable = System.Windows.Forms.DataGridViewTriState.False;
            this.Departament.SortMode = System.Windows.Forms.DataGridViewColumnSortMode.Automatic;
            this.Departament.Width = 93;
            // 
            // Correu
            // 
            this.Correu.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.AllCells;
            this.Correu.HeaderText = "Correu";
            this.Correu.Name = "Correu";
            this.Correu.ReadOnly = true;
            this.Correu.Resizable = System.Windows.Forms.DataGridViewTriState.False;
            this.Correu.SortMode = System.Windows.Forms.DataGridViewColumnSortMode.Automatic;
            this.Correu.Width = 63;
            // 
            // GestorHistorial
            // 
            this.BackColor = System.Drawing.Color.AliceBlue;
            this.BackgroundImageLayout = System.Windows.Forms.ImageLayout.None;
            this.ClientSize = new System.Drawing.Size(574, 88);
            this.ControlBox = false;
            this.Controls.Add(this.Graella);
            this.Controls.Add(this.Tancar);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
            this.Location = new System.Drawing.Point(52, 620);
            this.Name = "GestorHistorial";
            this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
            ((System.ComponentModel.ISupportInitialize)(this.Graella)).EndInit();
            this.ResumeLayout(false);

        }

        //Afegeix una trucada al fitxer XML
        public void Afegir_Trucada(string nom, string num, string dept, string mail)
        {
            
            //Registre = new Registre(nom, num, dept, mail);
            
            XmlNode Trucada = doc_xml.CreateElement("Trucada");

            XmlAttribute Data = doc_xml.CreateAttribute("Data");
            XmlAttribute Nom = doc_xml.CreateAttribute("Nom");
            XmlAttribute Num = doc_xml.CreateAttribute("Num");
            XmlAttribute Dept = doc_xml.CreateAttribute("Departament");
            XmlAttribute Mail = doc_xml.CreateAttribute("Correu");

            Data.InnerText = DateTime.Now.ToString();
            Nom.InnerText = nom;
            Num.InnerText = num;
            Dept.InnerText = dept;
            Mail.InnerText = mail;

            Trucada.Attributes.Append(Data);
            Trucada.Attributes.Append(Nom);
            Trucada.Attributes.Append(Num);
            Trucada.Attributes.Append(Dept);
            Trucada.Attributes.Append(Mail);

            doc_xml.DocumentElement.AppendChild(Trucada);

            doc_xml.Save("Hist.xml");

        }

        //Funcio que carrega el fitxer XML i mostra l'historial
        public void Mostrar_Historial()
        {
            //Empleno la graella
            Graella.Rows.Clear();

            XmlNodeList xnList = doc_xml.GetElementsByTagName("Trucada");

            foreach (XmlNode xn in xnList)
            {

                Graella.Rows.Add(xn.Attributes[0].InnerText.Trim(), xn.Attributes[1].InnerText.Trim(), xn.Attributes[2].InnerText.Trim(), xn.Attributes[3].InnerText.Trim(), xn.Attributes[4].InnerText.Trim());

            }

            //Mostro l'historial
            this.Show();

        }

        //Funció del boto tancar
        public void Tancar_Historial(object sender, EventArgs e)
        {
            //this.Close();

            this.Hide();
        }

        //Funcio per tractar els events de la Graella
        private void ClicAContingutGraella(object sender, DataGridViewCellEventArgs e)
        {
            //Si es un numero faig un click-to-call
            if (Graella.CurrentCell.ColumnIndex == 2)
            {

                /*String usuari = WindowsIdentity.GetCurrent().Name + "    ";

                usuari = usuari.Substring(13, 4);
                usuari = usuari.Trim();

                String extensio = Graella.CurrentCell.Value.ToString();

                string url = "http://10.240.111.3:9090/plugins/phoneplugin/click2call?callerusr=" + usuari + "&exttocall=" + extensio;

                //System.Diagnostics.Process.Start(url);

                System.Diagnostics.Process p = new System.Diagnostics.Process();
                p.StartInfo.FileName = "iexplore.exe";
                p.StartInfo.Arguments = url;
                p.Start();
                */
            }

            //Si es un mail creo un nou correu electronic
            if (Graella.CurrentCell.ColumnIndex == 4)
            {

                // Create the Outlook application by using inline initialization.
                //OutLook.Application oApp = new OutLook.Application();

                //Create the new message by using the simplest approach.
                //OutLook.MailItem oMsg = (OutLook.MailItem)oApp.CreateItem(OutLook.OlItemType.olMailItem);

                //Add a recipient.
                //OutLook.Recipient oRecip = (OutLook.Recipient)oMsg.Recipients.Add(Graella.CurrentCell.Value.ToString());
                //oRecip.Resolve();

                //Set the basic properties.
                //oMsg.Subject = "This is the subject of the test message";
                //oMsg.Body = "This is the text in the message.";

                // If you want to, display the message.
                //oMsg.Display(true);  //modal

            }

            //Si es un departament mostro la info del departament de la intranet
            if (Graella.CurrentCell.ColumnIndex == 3)
            {

                
            }



        }

        //Funció per fer el manteniment de l'Historial
        public void Mantenir_Historial(int nTrucades) 
        {
            XmlNodeList xnList = doc_xml.GetElementsByTagName("Trucada");

            int total = doc_xml.GetElementsByTagName("Trucada").Count;
            int eliminar;

            eliminar = total - nTrucades;


            for (int i = 0; i < eliminar;i++ )
            {

                doc_xml.DocumentElement.RemoveChild(xnList.Item(i));    
            
            }
        
        
        }

        #endregion
    }
}
