﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace IdentificadorDeTrucades
{
    class Popup
    {

        #region Atributs de la classe Popup

        //Imatge de fons del Popup
        protected Bitmap ImFonsPopUp = null;

        //Boto per tancar el Popup
        protected Bitmap ImBotoTanca = null;
        protected Point LocImBotoTanca = new Point();
        protected Size TamImBotoTanca = new Size();

        //Boto per mostrar l'historial
        protected Bitmap ImBotoHistorial = null;
        protected Point LocImBotoHistorial = new Point();
        protected Size TamImBotoHistorial = new Size();

        //Boto per afegir un contante
        protected Bitmap ImBotoContacte = null;
        protected Point LocImBotoContacte = new Point();
        protected Size TamImBotoContacte = new Size();

        //Foto de la persona que truca
        protected Bitmap ImFoto = null;
        protected Point LocImFoto = new Point();
        protected Size TamImFoto = new Size();

        //Nom, numero, departament i correu electrònic de la persona que truca
        protected TextPopup NomPT = new TextPopup();  
        protected TextPopup NumPT = new TextPopup();
        protected TextPopup DeptPT = new TextPopup();
        protected TextPopup MailPT = new TextPopup();

        #endregion

        #region Constructors del Popup

        //Constructor per defecte
        public Popup()
        { 
        
        }

        //Constructor amb paràmetres
        public Popup(Bitmap iFons, Bitmap iBT, Point lBT, Size tBT, Bitmap iBH, Point lBH, Size tBH, Bitmap iBC, Point lBC, Size tBC, Bitmap iPT, Point lPT, Size tPT, Rectangle rNoPT, String noPT, Rectangle rNuPT, String nuPT, Rectangle rDePT, String dePT, Rectangle rMaPT, String maPT) 
        {

            //Imatge de fons del Popup
            ImFonsPopUp = iFons;

            //Boto per tancar el Popup
            ImBotoTanca = iBT;
            LocImBotoTanca = lBT;
            TamImBotoTanca = tBT;

            //Boto per mostrar l'historial
            ImBotoHistorial = iBH;
            LocImBotoHistorial = lBH;
            TamImBotoHistorial = tBH;

            //Boto per afegir un contacte
            ImBotoContacte = iBC;
            LocImBotoContacte = lBC;
            TamImBotoContacte = tBC;

            //Foto de la persona que truca
            ImFoto = iPT;
            LocImFoto = lPT;
            TamImFoto = tPT;

            //Nom, numero, departament i correu electrònic de la persona que truca
            //RectangleNomPT = rNoPT;
            //NomPT = noPT;
            NomPT.ObtenirText = noPT;

            //RectangleNumPT = rNuPT;
            //NumPT = nuPT;
            NumPT.ObtenirText = nuPT;

            //RectangleDeptPT = rDePT;
            //DeptPT = dePT;
            DeptPT.ObtenirText = dePT;

            //RectangleMailPT = rMaPT;
            //MailPT = maPT;
            MailPT.ObtenirText = maPT;

        }

        #endregion

        #region Funcions de la classe Popup

        //Funcio per obtenir la imatge de fons del Popup
        public Bitmap ObtenirImFons
        {
            get { return ImFonsPopUp; }
            set { ImFonsPopUp = value; }
        }

        //Funcions per obtenir els atributs del boto tancar
        public Bitmap ObtenirImBotoTancar
        {
            get { return ImBotoTanca; }
            set { ImBotoTanca = value; }
        }

        public Point ObtenirLocBotoTancar
        {
            get { return LocImBotoTanca; }
            set { LocImBotoTanca = value; }
        }

        public Size ObtenirTamBotoTancar
        {
            get { return TamImBotoTanca; }
            set { TamImBotoTanca = value; }
        }

        //Funcions per obtenir els atributs del boto historial
        public Bitmap ObtenirImBotoHistorial
        {
            get { return ImBotoHistorial; }
            set { ImBotoHistorial = value; }
        }

        public Point ObtenirLocBotoHistorial
        {
            get { return LocImBotoHistorial; }
            set { LocImBotoHistorial = value; }
        }

        public Size ObtenirTamBotoHistorial
        {
            get { return TamImBotoHistorial; }
            set { TamImBotoHistorial = value; }
        }

        //Funcions per obtenir els atributs del boto contacte
        public Bitmap ObtenirImBotoContacte
        {
            get { return ImBotoContacte; }
            set { ImBotoContacte = value; }
        }

        public Point ObtenirLocBotoContacte
        {
            get { return LocImBotoContacte; }
            set { LocImBotoContacte = value; }
        }

        public Size ObtenirTamBotoContacte
        {
            get { return TamImBotoContacte; }
            set { TamImBotoContacte = value; }
        }

        //Funcions per obtenir els atributs de la foto
        public Bitmap ObtenirImFoto
        {
            get { return ImFoto; }
            set { ImFoto = value; }
        }

        public Point ObtenirLocFoto
        {
            get { return LocImFoto; }
            set { LocImFoto = value; }
        }

        public Size ObtenirTamFoto
        {
            get { return TamImFoto; }
            set { TamImFoto = value; }
        }

        //Textes del Popup
        public TextPopup ObtenirTPNomPT
        {
            get { return NomPT; }
            set { NomPT = value; }
        }

        public string ObtenirTextNom
        {
            get { return NomPT.ObtenirText; }
            set { NomPT.ObtenirText = value;}
        
        }

        public Color ObtenirColNormalNom
        {
            get { return NomPT.OtenirColorNormal; }
            set { NomPT.OtenirColorNormal = value; }
        }

        public Color ObtenirColEventNom
        {
            get { return NomPT.OtenirColorEvent; }
            set { NomPT.OtenirColorEvent = value; }
        }

        public Font ObtenirFontNormalNom
        {
            get { return NomPT.ObtenirFontNormal; }
            set { NomPT.ObtenirFontNormal = value; }
        
        }

        public Font ObtenirFontEventNom
        {
            get { return NomPT.ObtenirFontEvent; }
            set { NomPT.ObtenirFontEvent = value; }
        }

        public TextPopup ObtenirTPNumPT
        {
            get { return NumPT; }
            set { NumPT = value; }
        }

        public string ObtenirTextNum
        {
            get { return NumPT.ObtenirText; }
            set { NumPT.ObtenirText = value; }

        }

        public Color ObtenirColNormalNum
        {
            get { return NumPT.OtenirColorNormal; }
            set { NumPT.OtenirColorNormal = value; }
        }

        public Color ObtenirColEventNum
        {
            get { return NumPT.OtenirColorEvent; }
            set { NumPT.OtenirColorEvent = value; }
        }

        public Font ObtenirFontNormalNum
        {
            get { return NumPT.ObtenirFontNormal; }
            set { NumPT.ObtenirFontNormal = value; }

        }

        public Font ObtenirFontEventNum
        {
            get { return NumPT.ObtenirFontEvent; }
            set { NumPT.ObtenirFontEvent = value; }
        }

        public TextPopup ObtenirTPDeptPT
        {
            get { return DeptPT; }
            set { DeptPT = value; }
        }

        public string ObtenirTextDept
        {
            get { return DeptPT.ObtenirText; }
            set { DeptPT.ObtenirText = value; }

        }

        public Color ObtenirColNormalDept
        {
            get { return DeptPT.OtenirColorNormal; }
            set { DeptPT.OtenirColorNormal = value; }
        }

        public Color ObtenirColEventDept
        {
            get { return DeptPT.OtenirColorEvent; }
            set { DeptPT.OtenirColorEvent = value; }
        }

        public Font ObtenirFontNormalDept
        {
            get { return DeptPT.ObtenirFontNormal; }
            set { DeptPT.ObtenirFontNormal = value; }

        }

        public Font ObtenirFontEventDept
        {
            get { return DeptPT.ObtenirFontEvent; }
            set { DeptPT.ObtenirFontEvent = value; }
        }

        public TextPopup ObtenirTPMailPT
        {
            get { return MailPT; }
            set { MailPT = value; }
        }

        public string ObtenirTextMail
        {
            get { return MailPT.ObtenirText; }
            set { MailPT.ObtenirText = value; }

        }

        public Color ObtenirColNormalMail
        {
            get { return MailPT.OtenirColorNormal; }
            set { MailPT.OtenirColorNormal = value; }
        }

        public Color ObtenirColEventMail
        {
            get { return MailPT.OtenirColorEvent; }
            set { MailPT.OtenirColorEvent = value; }
        }

        public Font ObtenirFontNormalMail
        {
            get { return MailPT.ObtenirFontNormal; }
            set { MailPT.ObtenirFontNormal = value; }

        }

        public Font ObtenirFontEventMail
        {
            get { return MailPT.ObtenirFontEvent; }
            set { MailPT.ObtenirFontEvent = value; }
        }

        #endregion

    }
}
