﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;

namespace IdentificadorDeTrucades
{
    class TextPopup
    {

        #region Atributs de la classe TextPopup

        protected string text;

        protected Color colTextNormal = Color.FromArgb(255, 79, 0);
        protected Color colTextEvent = Color.FromArgb(255, 79, 0);

        protected Font fontTextNormal = new Font("Arial", 12, FontStyle.Regular, GraphicsUnit.Pixel);
        protected Font fontTextEvent = new Font("Arial", 12, FontStyle.Bold, GraphicsUnit.Pixel);

        #endregion

        #region Constructors de la classe TextPopup

        //Constructor per defecte
        public TextPopup()
        {             
        }

        //Constructor amb parametres
        public TextPopup(string txt, Color CNText, Color CEText, Font FNText, Font FEText)
        {
            text = txt;
            colTextNormal = CNText;
            colTextEvent = CEText;
            fontTextNormal = FNText;
            fontTextEvent = FEText;
        }

        #endregion

        #region Metodes de la classe TextPopup

        //Metode per obtenir el text
        public string ObtenirText
        {
            get{return text;}
            set{text = value;}
        }

        //Metode per obtenir el color normal del text
        public Color OtenirColorNormal
        {
            get{return colTextNormal;}
            set{colTextNormal = value;}
        }

        //Metode per obtenir el color event del text
        public Color OtenirColorEvent
        {
            get{return colTextEvent;}
            set{colTextEvent = value;}
        }

        //Metode per obtenir la font normal del text
        public Font ObtenirFontNormal
        {
            get{return fontTextNormal;}
            set{fontTextNormal = value;}
        }

        //Metode per obtenir la font event del text
        public Font ObtenirFontEvent
        {
            get{return fontTextEvent;}
            set{fontTextEvent = value;}
        }

        //Funció que defineix el que s'ha de fer en cas que es fagi clic a un número de telèfon
        public void ClicTelf()
        {
            MessageBox.Show("S'ha fet clic al Telf");
        }

        //Funció que defineix el que s'ha de fer en cas que es fagi clic a un número de departament
        public void ClicDept()
        {
            MessageBox.Show("S'ha fet clic al Departament");
        }

        //Funció que defineix el que s'ha de fer en cas que es fagi clic a un mail
        public void ClicMail()
        {
            MessageBox.Show("S'ha fet clic al Mail");
        }

        #endregion

    }
}
